#include "nSystem.h"

int debugging= TRUE;

void hito(nTask dir, char *hito);
void avanzar(nTask t);
void esperar(nTask t, char *hitoEsp);
char *esperarAlt(nTask *psender, char *hitoEsp);
void nohito(char *msg);
int finalizador(nTask dir, nTask t, char *termino);
int terminar(nTask dir, nTask t, char *nombre);

int testRecepcion(int n);
int listener(int id, nTask sender, int n);

int testTimeout(int replyDT);
int listenerB(int id, nTask sender, int dt1, int dt2);

int testTimeout2();

int nMain(int argc, char** argv) {
  // debugging= FALSE;

  nPrintf("\n");
  nPrintf("test de recepcion\n");
  nPrintf("*****************\n\n");
  testRecepcion(10);

  nPrintf("\n");
  nPrintf("test de timeout que expira\n");
  nPrintf("**************************\n\n");
  testTimeout(0);

  nPrintf("\n");
  nPrintf("test de timeout que no expira\n");
  nPrintf("*****************************\n\n");
  testTimeout2();

  nPrintf("\n");
  nPrintf("test de nReplyMulticast\n");
  nPrintf("***********************\n\n");
  nPrintf("Una vez que el timeout expira, no se aceptan nuevos nListen,\n");
  nPrintf("pero se espera que los que si alcanzaron hagan nReplyMulticast.\n");
  testTimeout(4000);

  nPrintf("\n");
  nPrintf("Felicitaciones: su tarea funciona\n\n");

  return 0;
}

int listener(int id, nTask sender, int n) {
  int j;
  char name[20];
  sprintf(name, "listener %d", id);
  nSetTaskName(name);
  for (j= 0; j<n; j++) {
    int *pi= (int *)nListen(sender);
    if (*pi!=j)
      nFatalError("listener", "listener escucha %d en vez de %d\n", *pi, j);
    nPrintf("listener %d escucha %d\n", id, j);
    nReplyMulticast(sender);
  }
  return 0;
}

int testRecepcion(int n) {
  int i;
  nTask yo= nCurrentTask();
  nTask t1= nEmitTask(listener, 1, yo, n);
  nTask t2= nEmitTask(listener, 2, yo, n);
  nTask t3= nEmitTask(listener, 3, yo, n);
  nTask targets[3];
  targets[0]= t1; targets[1]= t2; targets[2]= t3;
  for (i= 0; i<n; i++) {
    int rc= nMulticast(targets, 3, &i, -1);
    if (rc!=3)
      nFatalError("testRecepcion", "nMulticast retorna %d en vez de 3\n", rc);
  }
  nWaitTask(t1); nWaitTask(t2); nWaitTask(t3);
  return 0;
}

int listenerB(int id, nTask sender, int dt1, int dt2) {
  int *pmsg;
  char name[20];
  sprintf(name, "listenerB %d", id);
  nSetTaskName(name);
  nSleep(dt1);
  nPrintf("listenerB %d invoca nListen\n", id);
  pmsg= (int *)nListen(sender);
  if (*pmsg!=123)
    nFatalError("listenerB", "listenerB %d escucho %d en vez de 123\n",
                id, *pmsg);
  else {
    nPrintf("Bien, listenerB %d escucho el mensaje correcto\n", id);
    nSleep(dt2);
    nPrintf("listenerB %d responde multicast\n", id);
    nReplyMulticast(sender);
  }
  return 0;
}

int testTimeout(int replyDT) {
  int msg= 123, rc;
  nTask yo= nCurrentTask();
  nTask t1= nEmitTask(listenerB, 1, yo, 0, replyDT);
  nTask t2= nEmitTask(listenerB, 2, yo, 4000, 0);
  nTask t3= nEmitTask(listenerB, 3, yo, 2000, 0);
  nTask targets[3];
  nSleep(1000);
  targets[0]= t1; targets[1]= t2; targets[2]= t3;
  nPrintf("Emitiendo multicast\n");
  rc= nMulticast(targets, 3, &msg, 2000); /* un segundo de timeout */
  if (rc!=2)
    nFatalError("testTimeout",
                "%d tareas escucharon, pero debian ser solo 2\n", rc);
  else {
    nPrintf("Bien, solo 2 tareas escucharon el multicast.\n");
    nPrintf("Emitiendo 2do. multicast\n");
  }
  /* Ahora desbloqueamos t3 */
  rc= nMulticast(targets, 3, &msg, 2000);
  if (rc!=1)
    nFatalError("testTimeOut",
                "%d tareas escucharon, pero debio ser solo 1\n", rc);
  else
    nPrintf("Bien, solo 1 tarea escucho el multicast.\n");
  nWaitTask(t1); nWaitTask(t2); nWaitTask(t3);
  return 0;
}

int testTimeout2() {
  int msg= 123, rc;
  nTask yo= nCurrentTask();
  nTask t1= nEmitTask(listenerB, 1, yo, 0, 0);
  nTask t2= nEmitTask(listenerB, 2, yo, 3000, 0);
  nTask t3= nEmitTask(listenerB, 3, yo, 2000, 0);
  nTask targets[3];
  nSleep(1000);
  targets[0]= t1; targets[1]= t2; targets[2]= t3;
  nPrintf("Emitiendo multicast\n");
  rc= nMulticast(targets, 3, &msg, 4000); /* un segundo de timeout */
  if (rc!=3)
    nFatalError("testTimeout",
                "%d tareas escucharon, pero debian ser 3\n", rc);
  else
    nPrintf("Bien, las 2 tareas escucharon el multicast.\n");
  nWaitTask(t1); nWaitTask(t2); nWaitTask(t3);
  return 0;
}

